{ config, lib, ... }:

with lib;

{
  imports = [ 
    ../../options/machine.nix 
    ./Ophanim.nix
  ];

  config.machine = {
    hostName = "Ophanim";
    allowUnfree = true;
    conffiles = [
      "etcvars"
      "security"
      "zsh"
    ];
    pkgs = [
      "base"
      "emacs"
      "server"
    ];
    services = [
      "fail2ban"
      "gitea"
      "hydra"
      "mailserver"
      "mariaDB"
      "nextcloud"
      "nginx"
      "openssh"
    ];
    firewall = {
      allowPing = false;
      allowedUDPPorts = [ 22 80 443 ];
      allowedTCPPorts = [ 80 443 ]; # 5222 5269 ];
      allowedUDPPortRanges = [];
      allowedTCPPortRanges = [];
    };
  };
}
